var ctx;
var img;
var imgInstance;
var canvasInstance;
var clicksBlack = 0;
var clicksBlue = 0;
var clicksRed = 0;
var clicksGreen = 0;
var clicksYellow = 0;
var clicksGray = 0;
var clicksOrange = 0;
var clicksPurple = 0;
var startx = new Array();
var endx = new Array();
var starty = new Array();
var endy = new Array();
var canvases = new Array();
var arg = new Array();
var arg_Draw = new Array();
var tempArrayNew = new Array();
var tempArrayNew_Draw = new Array();
var tempArray_Angle = new Array();
var popEnd;
var popEnd_Draw;
var tempArrayCount = new Array();
var new_arr_count = new Array();

//immediately invoked functional expression to generate base canvas
var baseCanvas;
$(function () {
    baseCanvas = new fabric.Canvas('myCanvas', {
        hoverCursor: 'pointer',
        selection: false,
        width: 800,
        height: 800
    });
});

//generate array of canvases that can be indexed
function createCanvasHistory() {

    var canvasId = 'canvasHistory' + canvases.length;
    var newCanvas = $("<canvas></canvas>");
    newCanvas.attr('id', canvasId);
    newCanvas.attr('class', 'canvas');
    newCanvas.css('z-index', canvases.length + 2);
    canvases.push(newCanvas);

    newCanvas.insertAfter($("#canvases"));

    canvas = new fabric.Canvas(canvasId, {
        hoverCursor: 'pointer',
        selection: false,
        width: 800,
        height: 800
    });

    return canvas;
}


//generate array of canvases that can be indexed for free draw
function createCanvasHistoryDraw() {
    var canvasId = 'canvasHistory' + canvases.length;
    var newCanvas = $("<canvas></canvas>");
    newCanvas.attr('id', canvasId);
    newCanvas.attr('class', 'canvas');
    newCanvas.css('z-index', canvases.length + 2);
    canvases.push(newCanvas);

    newCanvas.insertAfter($("#canvases"));

    canvas = new fabric.Canvas(canvasId, {
        hoverCursor: 'pointer',
        selection: false,
        width: 800,
        height: 800,
        isDrawingMode: true
    });

    canvas.freeDrawingBrush.width = $('#selWidth').val();
    canvas.freeDrawingBrush.color = $('#selColor').val();

    return canvas;
}

//grey filter option
function letsGrey() {

    imgInstance.filters.push(new fabric.Image.filters.Grayscale());
    imgInstance.applyFilters(baseCanvas.renderAll.bind(baseCanvas));

    $("#grayer").attr('disabled', true);

}

//invert filter option
function letsInvert() {

    imgInstance.filters.push(new fabric.Image.filters.Invert());
    imgInstance.applyFilters(baseCanvas.renderAll.bind(baseCanvas));

    $("#inverter").attr('disabled', true);

}

//remove white filter
function letsRemoveWhite() {

    imgInstance.filters.push(new fabric.Image.filters.RemoveWhite());
    imgInstance.applyFilters(baseCanvas.renderAll.bind(baseCanvas));

    $("#remover").attr('disabled', true);
}

//brightness filter
function letsBright() {

    var valueB = document.getElementById("brightness-value").value;
    var numVal = parseInt(valueB);

    imgInstance.filters.push(new fabric.Image.filters.Brightness({
        brightness: numVal
    }));
    imgInstance.applyFilters(baseCanvas.renderAll.bind(baseCanvas));
}

//sharpen image filter
function letsSharpen() {

    imgInstance.filters.push(new fabric.Image.filters.Convolute({
        matrix: [0, -1, 0,
                -1, 5, -1,
                 0, -1, 0]
    }));
    imgInstance.applyFilters(baseCanvas.renderAll.bind(baseCanvas));

    $("#sharper").attr('disabled', true);
}


//onloaded invokes this function to collect input
function letsBegin() {

    $("#file_input").change(function (e) {

        $("#option1").attr('disabled', false);
        $("#option2").attr('disabled', false);
        $("#option3").attr('disabled', false);
        $("#option4").attr('disabled', false);
        $("#grayer").attr('disabled', false);
        $("#remover").attr('disabled', false);
        $("#inverter").attr('disabled', false);
        $("#sharper").attr('disabled', false);
        $("#brighter").attr('disabled', false);
        $("#brightness-value").attr('disabled', false);

        var URL = window.webkitURL || window.URL;
        var url = URL.createObjectURL(e.target.files[0]);
        img = new Image();
        img.src = url;
        img.onload = function () {
            ctx = document.getElementById('myCanvas').getContext("2d");
            imgInstance = new fabric.Image(img, {
                left: 0,
                width: 800,
                height: 800,
                top: 0,
                angle: 0,
                opacity: 1
            });
            baseCanvas.add(imgInstance);
            $("#file_input").attr('disabled', true);
        }
    });


}

//function for measuring objects
function letsMeasure() {
    $("#mean_option").attr('disabled', false);

    $("#grayer").attr('disabled', true);
    $("#remover").attr('disabled', true);
    $("#inverter").attr('disabled', true);
    $("#sharper").attr('disabled', true);
    $("#brighter").attr('disabled', true);
    $("#brightness-value").attr('disabled', true);


    var magnify = document.getElementById('obj_mag').value;
    var realPixel = document.getElementById('pixel_size').value;
    var realBinning = document.getElementById('bin_size').value;
    var realMount = document.getElementById('c_mount').value;
    var realLens = document.getElementById('lens_mag').value;
    var realWidth = document.getElementById('real_width').value;
    var realHeight = document.getElementById('real_height').value;

    var divisorScale = magnify * realMount * realLens;
    var ccdBin = realPixel * realBinning;
    var actualPixelSize = ccdBin / divisorScale;
    var scaled_factor = realHeight / 800;
    var normalizedSize = actualPixelSize * scaled_factor;

    var line, isDown;
    var arr = new Array();
    var startx = new Array();
    var endx = new Array();
    var starty = new Array();
    var endy = new Array();
    var temp = 0;
    var graphtype;
    trigger = "1";
    var text;

    canvas = createCanvasHistory();
    fabric.Object.prototype.transparentCorners = false;

    canvas.on('mouse:down', function (o) {
        if (trigger == "1") {
            isDown = true;
            var pointer = canvas.getPointer(o.e);
            var points = [pointer.x, pointer.y, pointer.x, pointer.y];
            startx[temp] = pointer.x;
            starty[temp] = pointer.y;
            line = new fabric.Line(points, {
                strokeWidth: $('#selWidth').val(),
                stroke: $('#selColor').val(),
                originX: 'center',
                originY: 'center'
            });
            canvas.add(line);
        } else {
            canvas.forEachObject(function (o) {
                o.setCoords();
            });
        }
    });

    canvas.on('mouse:move', function (o) {
        canvas.remove(text);
        canvas.renderAll();
        if (!isDown) return;
        var pointer = canvas.getPointer(o.e);
        line.set({
            x2: pointer.x,
            y2: pointer.y
        });
        endx[temp] = pointer.x;
        endy[temp] = pointer.y;

        if (trigger == "1") {
            var px = Calculate.lineLength(startx[temp], starty[temp], endx[temp], endy[temp]).toFixed(2);
            text = new fabric.Text('Length ' + px, {
                left: endx[temp],
                top: endy[temp],
                stroke: $('#selColor').val(),
                fontSize: 18
            });
            tempArrayNew.push(px);
            canvas.add(text);
        }
        canvas.renderAll();
    });

    canvas.on('mouse:up', function (o) {
        var pointer = canvas.getPointer(o.e);
        isDown = false;
        popEnd = tempArrayNew.slice(-1).pop();
        arg.push(popEnd);
    });

    canvas.on('mouse:over', function (e) {
        e.target.setStroke('blue');
        canvas.renderAll();
    });

    canvas.on('mouse:out', function (e) {
        e.target.setStroke('red');
        canvas.renderAll();

    });
    var Calculate = {
        lineLength: function (x1, y1, x2, y2) {
            return normalizedSize * (Math.sqrt(Math.pow(x2 * 1 - x1 * 1, 2) + Math.pow(y2 * 1 - y1 * 1, 2)));
        }
    }
}


//function for free draw option
function letsDraw() {
    $("#mean_Draw_option").attr('disabled', false);

    $("#grayer").attr('disabled', true);
    $("#remover").attr('disabled', true);
    $("#inverter").attr('disabled', true);
    $("#sharper").attr('disabled', true);
    $("#brighter").attr('disabled', true);
    $("#brightness-value").attr('disabled', true);


    canvas = createCanvasHistoryDraw();
    fabric.Object.prototype.transparentCorners = false;

    var magnify = document.getElementById('obj_mag').value;
    var realPixel = document.getElementById('pixel_size').value;
    var realBinning = document.getElementById('bin_size').value;
    var realMount = document.getElementById('c_mount').value;
    var realLens = document.getElementById('lens_mag').value;
    var realWidth = document.getElementById('real_width').value;
    var realHeight = document.getElementById('real_height').value;

    var divisorScale = magnify * realMount * realLens;
    var ccdBin = realPixel * realBinning;
    var actualPixelSize = ccdBin / divisorScale;
    var scaled_factor = realHeight / 800;
    var normalizedSize = actualPixelSize * scaled_factor;

    var line, isDown;
    var arr = new Array();
    var startx = new Array();
    var endx = new Array();
    var starty = new Array();
    var endy = new Array();
    var temp = 0;
    var graphtype;
    trigger = "1";
    var text;
    var points = [];

    canvas.on('mouse:down', function (o) {
        if (trigger == "1") {
            isDown = true;
            var pointer = canvas.getPointer(o.e);
            points = [
                {
                    x: pointer.x,
                    y: pointer.y
                }
            ];
            startx[temp] = pointer.x;
            starty[temp] = pointer.y;
            line = new fabric.Polyline(points, {
                strokeWidth: $('#selWidth').val(),
                stroke: $('#selColor').val(),
                originX: 'center',
                originY: 'center'
            });
            canvas.add(line);
        } else {
            canvas.forEachObject(function (o) {
                o.setCoords();

            });
        }
    });

    canvas.on('mouse:move', function (o) {
        canvas.remove(text);
        canvas.renderAll();
        if (!isDown) return;
        var pointer = canvas.getPointer(o.e);
        line.set({
            x2: pointer.x,
            y2: pointer.y
        });

        points.push({
            x: pointer.x,
            y: pointer.y
        });
        endx[temp] = pointer.x;
        endy[temp] = pointer.y;

        if (trigger == "1") {
            var px = Calculate.lineLength(points).toFixed(2);
            text = new fabric.Text('Length ' + px, {
                left: endx[temp],
                top: endy[temp],
                stroke: $('#selColor').val(),
                fontSize: 18
            });
            tempArrayNew_Draw.push(px);
            canvas.add(text);
        }

        canvas.renderAll();
    });

    canvas.on('mouse:up', function (o) {
        var pointer = canvas.getPointer(o.e);
        isDown = false;
        popEnd_Draw = tempArrayNew_Draw.slice(-1).pop();
        arg_Draw.push(popEnd_Draw);
    });

    var Calculate = {
        lineLength: function (pointArray) {
            var distance = 0;

            for (var i = 0; i < pointArray.length - 1; i++) {
                var p1 = pointArray[i];
                var p2 = pointArray[i + 1];
                distance += normalizedSize * (Math.sqrt(Math.pow(p2.x * 1 - p1.x * 1, 2) + Math.pow(p2.y * 1 - p1.y * 1, 2)));
            }
            return distance;
        }
    }
}

//function for counting objects
function letsCount() {
    $("#mean_count_option").attr('disabled', false);
    $("#chemoTaxis_option").attr('disabled', false);
    $("#avoidTaxis_option").attr('disabled', false);
    $("#thermoTaxis_option").attr('disabled', false);
    $("#saltTaxis_option").attr('disabled', false);
    $("#aversionTaxis_option").attr('disabled', false);
    $("#quadTaxis_option").attr('disabled', false);

    $("#grayer").attr('disabled', true);
    $("#remover").attr('disabled', true);
    $("#inverter").attr('disabled', true);
    $("#sharper").attr('disabled', true);
    $("#brighter").attr('disabled', true);
    $("#brightness-value").attr('disabled', true);


    canvas = createCanvasHistory();

    canvas.on('mouse:down', function (o) {
        DrawCircle(canvas, o.e.offsetX - 12, o.e.offsetY - 12, true);
        counterFunc();
    })
}

//draw dots for counting
function DrawCircle(canvas, x, y, isDown) {

    fabric.Object.prototype.transparentCorners = false;
    var color = $('#selColor').val();
    var thickness = $('#selWidth').val();

    var circle = new fabric.Circle({
        radius: thickness,
        fill: color,
        left: x,
        top: y
    });
    canvas.add(circle);
}

//function for measuring angles
function letsAngle() {
    $("#mean_Angle_option").attr('disabled', false);

    $("#grayer").attr('disabled', true);
    $("#remover").attr('disabled', true);
    $("#inverter").attr('disabled', true);
    $("#sharper").attr('disabled', true);
    $("#brighter").attr('disabled', true);
    $("#brightness-value").attr('disabled', true);


    canvas = createCanvasHistory();
    fabric.Object.prototype.transparentCorners = false;

    var text1 = new fabric.Text('0', {
        fontSize: 18,
        stroke: $('#selColor').val(),
        fontFamily: 'Arial',
        originX: 'center',
        originY: 'bottom'
    });
    fabric.Object.prototype.originX = fabric.Object.prototype.originY = 'center';

    function makeTriangle(left, top, line1, line2, line3, line4) {
        var c = new fabric.Triangle({
            left: left,
            top: top,
            strokeWidth: 2,
            fill: '#fff',
            stroke: '#666',
            angle: -180,
            width: 10,
            height: 10
        });
        c.hasControls = c.hasBorders = false;
        c.line1 = line1;
        c.line2 = line2;
        c.line3 = line3;
        c.line4 = line4;
        return c;
    }

    function makeCircle(left, top, line1, line2, line3, line4) {
        var c = new fabric.Circle({
            strokeWidth: 1,
            fill: '',
            stroke: '#666',
            radius: 18,
            width: 10,
            height: 10,
            originX: 'center',
            originY: 'center'
        });
        var group = new fabric.Group([text1, c], {
            left: left,
            top: top
        });
        group.hasControls = false;
        group.line1 = line1;
        group.line2 = line2;
        group.line3 = line3;
        group.line4 = line4;
        return group;
    }

    function makeLine(coords) {
        return new fabric.Line(coords, {
            fill: 'red',
            stroke: $('#selColor').val(),
            strokeWidth: 2,
            selectable: false
        });
    }

    var line2 = makeLine([250, 175, 250, 250]),
        line3 = makeLine([250, 250, 300, 350]),
        line4 = makeLine([250, 250, 200, 350]);

    canvas.add(line3, line4);
    canvas.add(
        makeCircle(line2.get('x2'), line2.get('y2'), line2, line3, line4),
        makeTriangle(line3.get('x2'), line3.get('y2'), line3),
        makeTriangle(line4.get('x2'), line4.get('y2'), line4));

    canvas.on('object:moving', function (e) {
        var p = e.target;
        p.line1 && p.line1.set({
            'x2': p.left,
            'y2': p.top
        });
        p.line2 && p.line2.set({
            'x1': p.left,
            'y1': p.top
        });
        p.line3 && p.line3.set({
            'x1': p.left,
            'y1': p.top
        });
        p.line4 && p.line4.set({
            'x1': p.left,
            'y1': p.top
        });
        canvas.renderAll();

        y11 = line3.get('y1');
        y12 = line3.get('y2');
        y21 = line4.get('y1');
        y22 = line4.get('y2');

        x11 = line3.get('x1');
        x12 = line3.get('x2');
        x21 = line4.get('x1');
        x22 = line4.get('x2');

        angle1 = Math.atan2(y11 - y12, x11 - x12);
        angle2 = Math.atan2(y21 - y22, x21 - x22);

        angle = angle1 - angle2;
        angle = angle * 180 / Math.PI;

        if (angle < 0)
            angle = -angle;
        if (360 - angle < angle)
            angle = 360 - angle;
        text1.setText(angle.toFixed(0));
    });
}

//adding counter tally to html
function counterFunc() {
    var colorChoice = $('#selColor').val();
    if (colorChoice == "blue") {
        clicksBlue += 1;
        document.getElementById("clicksBlue").innerHTML = "Count: " + clicksBlue + "  ";
    } else if (colorChoice == "red") {
        clicksRed += 1;
        document.getElementById("clicksRed").innerHTML = "Count: " + clicksRed + "  ";
    } else if (colorChoice == "green") {
        clicksGreen += 1;
        document.getElementById("clicksGreen").innerHTML = "Count: " + clicksGreen + "  ";
    } else if (colorChoice == "yellow") {
        clicksYellow += 1;
        document.getElementById("clicksYellow").innerHTML = "Count: " + clicksYellow + "  ";
    } else if (colorChoice == "black") {
        clicksBlack += 1;
        document.getElementById("clicksBlack").innerHTML = "Count: " + clicksBlack + "  ";
    } else if (colorChoice == "gray") {
        clicksGray += 1;
        document.getElementById("clicksGray").innerHTML = "Count: " + clicksGray + "  ";
    } else if (colorChoice == "orange") {
        clicksOrange += 1;
        document.getElementById("clicksOrange").innerHTML = "Count: " + clicksOrange + "  ";
    } else if (colorChoice == "purple") {
        clicksPurple += 1;
        document.getElementById("clicksPurple").innerHTML = "Count: " + clicksPurple + "  ";
    }
}

///////////////
///from here down is a series of functions that report 
//various statistics
function mean_count() {

    tempArrayCount.push(clicksBlue);
    tempArrayCount.push(clicksRed);
    tempArrayCount.push(clicksGreen);
    tempArrayCount.push(clicksYellow);
    tempArrayCount.push(clicksBlack);
    tempArrayCount.push(clicksGray);
    tempArrayCount.push(clicksOrange);
    tempArrayCount.push(clicksOrange);
    tempArrayCount.push(clicksPurple);
    var tmp;

    for (var j = 0; j < tempArrayCount.length; j++) {
        tmp = tempArrayCount[j];

        if (tmp !== 0) {
            new_arr_count.push(tmp);
        }
    }

    var sum = 0;
    for (var i = 0; i < new_arr_count.length; i++) {
        sum += parseInt(new_arr_count[i]);
    }
    var averg = (sum / new_arr_count.length).toFixed(2);
    var line_median = parseInt(median(new_arr_count));
    var line_variance = variance(new_arr_count).toFixed(2);
    var sd = Math.sqrt(variance(new_arr_count));
    var se = Math.sqrt(variance(new_arr_count) / (new_arr_count.length - 1));
    alert("Average: " + averg + " Median: " + line_median.toFixed(2) + " Variance: " + line_variance + " Standard Deviation: " + sd.toFixed(2) + " Standard Error: " + se.toFixed(2));
}

//mean count
function mean() {
    if (arg.length > 0) {
        var sum = 0;
        for (var i = 0; i < arg.length; i++) {
            sum += parseInt(arg[i]);
        }
        var averg = (sum / arg.length).toFixed(2);
        var line_median = parseInt(median(arg));
        var line_variance = variance(arg).toFixed(2);
        var sd = Math.sqrt(variance(arg));
        var se = Math.sqrt(variance(arg) / (arg.length - 1));
        alert("Average: " + averg + " Median: " + line_median.toFixed(2) + " Variance: " + line_variance + " Standard Deviation: " + sd.toFixed(2) + " Standard Error: " + se.toFixed(2));
    } else {
        alert("no measurements");
    }
}

function mean_Draw() {
    if (arg_Draw.length > 0) {
        var sum = 0;
        for (var i = 0; i < arg_Draw.length; i++) {
            sum += parseInt(arg_Draw[i]);
        }
        var averg = (sum / arg_Draw.length).toFixed(2);
        var line_median_Draw = parseInt(median(arg_Draw));
        var line_variance_Draw = variance(arg_Draw).toFixed(2);
        var sd = Math.sqrt(variance(arg_Draw));
        var se = Math.sqrt(variance(arg_Draw) / (arg_Draw.length - 1));
        alert("Average: " + averg + " Median: " + line_median_Draw.toFixed(2) + " Variance: " + line_variance_Draw + " Standard Deviation: " + sd.toFixed(2) + " Standard Error: " + se.toFixed(2));
    } else {
        alert("no measurements");
    }
}


function median(arr) {
    arr.sort(function (a, b) {
        return a - b
    });
    var median = 0;
    if (arr.length % 2 == 1) {
        median = arr[(arr.length + 1) / 2 - 1];
    } else {
        median = (1 * arr[arr.length / 2 - 1] + 1 * arr[arr.length / 2]) / 2;
    }
    return median
}

function variance(arr) {
    var len = 0;
    var sum = 0;
    for (var i = 0; i < arr.length; i++) {
        if (arr[i] == "") {} else if (isNaN(arr[i])) {
            alert(arr[i] + " is not number, Variance Calculation failed!");
            return 0;
        } else {
            len = len + 1;
            sum = sum + parseFloat(arr[i]);
        }
    }
    var v = 0;
    if (len > 1) {
        var mean = sum / len;
        for (var i = 0; i < arr.length; i++) {
            if (arr[i] == "") {} else {
                v = v + (arr[i] - mean) * (arr[i] - mean);
            }
        }
        return v / len;
    } else {
        return 0;
    }
}

/////////////END of statistics 


//calculate C.I.
function chemoIndex() {
    var taxisIn;
    var taxisArray = [];
    var totalAssay = 0;
    var diffAssay;
    var chemotaxisIndex;

    taxisIn = prompt("enter values for odor,control,and middle:", "e.g. 110,20,30");
    taxisArray = taxisIn.split(',');

    for (var i = 0; i < taxisArray.length; i++) {
        totalAssay += parseInt(taxisArray[i]);
    }

    diffAssay = taxisArray[0] - taxisArray[1];
    chemotaxisIndex = diffAssay / totalAssay;

    if (taxisArray.length == 3) {
        alert("Chemotaxis Index: " + chemotaxisIndex.toFixed(6));
    } else {
        alert("incorrect data entry");
    }
}


//calc A.I.
function aversionIndex() {
    var taxisIn;
    var taxisArray = [];
    var totalAssay = 0;
    var chemotaxisIndex;

    taxisIn = prompt("enter values for chemical and control:", "e.g. 102,23");
    taxisArray = taxisIn.split(',');

    for (var i = 0; i < taxisArray.length; i++) {
        totalAssay += parseInt(taxisArray[i]);
    }

    chemotaxisIndex = taxisArray[0] / totalAssay;

    if (taxisArray.length == 2) {
        alert("Aversion Index (soluble): " + chemotaxisIndex.toFixed(6));
    } else {
        alert("incorrect data entry");
    }
}


//calc quadrant assay index
function quadIndex() {
    var taxisIn;
    var taxisArray = [];
    var totalAssay = 0;
    var diffAssayA;
    var diffAssayB;
    var chemotaxisIndex;

    taxisIn = prompt("enter values for compound in QA, control in QB, compound in QA', and control in QB':", "e.g. 20,86,32,94");
    taxisArray = taxisIn.split(',');

    for (var i = 0; i < taxisArray.length; i++) {
        totalAssay += parseInt(taxisArray[i]);
    }

    diffAssayA = taxisArray[0] - taxisArray[1];
    diffAssayB = taxisArray[2] - taxisArray[3];
    chemotaxisIndex = diffAssayA / diffAssayB;

    if (taxisArray.length == 4) {
        alert("Quadrant Chemotaxis Index: " + chemotaxisIndex.toFixed(6));
    } else {
        alert("incorrect data entry");
    }
}


//calc C.I. for water soluble
function saltIndex() {
    var taxisIn;
    var taxisArray = [];
    var totalAssay = 0;
    var diffAssay;
    var chemotaxisIndex;

    taxisIn = prompt("enter values for soluble compound and control:", "e.g. 112,14");
    taxisArray = taxisIn.split(',');

    for (var i = 0; i < taxisArray.length; i++) {
        totalAssay += parseInt(taxisArray[i]);
    }

    diffAssay = taxisArray[0] - taxisArray[1];
    chemotaxisIndex = diffAssay / totalAssay;

    if (taxisArray.length == 2) {
        alert("Chemotaxis Index (soluble): " + chemotaxisIndex.toFixed(6));
    } else {
        alert("incorrect data entry");
    }
}

//calc odor avoidance (volatile)
function avoidIndex() {
    var taxisIn;
    var taxisArray = [];
    var totalAssay = 0;
    var diffAssay;
    var avoidtaxisIndex;

    taxisIn = prompt("enter values for six (A-F) panels starting with odor (A):", "e.g. 102,80,30,12,2,0");
    taxisArray = taxisIn.split(',');

    for (var i = 0; i < taxisArray.length; i++) {
        totalAssay += parseInt(taxisArray[i]);
    }

    var diffAssay1 = parseInt(taxisArray[0]) + parseInt(taxisArray[1]);
    var diffAssay2 = parseInt(taxisArray[4]) + parseInt(taxisArray[5]);
    diffAssay = diffAssay1 - diffAssay2;
    avoidtaxisIndex = diffAssay / totalAssay;

    if (taxisArray.length == 6) {
        alert("Avoidance Index: " + avoidtaxisIndex.toFixed(6));
    } else {
        alert("incorrect data entry");
    }
}


//thermo
function thermoIndex() {
    var taxisIn;
    var taxisArray = [];
    var totalAssay = 0;
    var thermotaxisIndex;

    taxisIn = prompt("enter values for eight panels starting with lowest temperature", "e.g. 120,23,31,22,20,12,11,2");

    taxisArray = taxisIn.split(',');
    for (var i = 0; i < taxisArray.length; i++) {
        totalAssay += parseInt(taxisArray[i]);
    }
    var panelOne = parseInt(taxisArray[0]) * -4;
    var panelTwo = parseInt(taxisArray[1]) * -3;
    var panelThree = parseInt(taxisArray[2]) * -2;
    var panelFour = parseInt(taxisArray[3]) * -1;
    var panelFive = parseInt(taxisArray[4]) * 1;
    var panelSix = parseInt(taxisArray[5]) * 2;
    var panelSeven = parseInt(taxisArray[6]) * 3;
    var panelEight = parseInt(taxisArray[7]) * 4;

    var totalWeighted = parseInt(panelOne) + parseInt(panelTwo) + parseInt(panelThree) + parseInt(panelFour) + parseInt(panelFive) + parseInt(panelSix) + parseInt(panelSeven) + parseInt(panelEight);

    thermotaxisIndex = totalWeighted / totalAssay;

    if (taxisArray.length == 8) {
        alert("Thermotaxis Index: " + thermotaxisIndex.toFixed(6));
    } else {
        alert("incorrect data entry");
    }
}

////
////////////////
//from here down are a series of functions related to t-test calculation 
//for each array

function t_test() {
    var x = document.getElementById("t_test_option1").value;
    var y = document.getElementById("t_test_option2").value;
    var degF = document.getElementById("degF").value;
    x = x.replace(' ', '');
    y = y.replace(' ', '');
    var arr = x.split(',');
    var arr2 = y.split(',');
    if (arr.length !== arr2.length) {
        alert("unequal arrays")
    } else {
        var xm1 = 0;
        var xm2 = 0;
        var total1 = 0;
        var total2 = 0;
        for (var j = 0; j < arr.length; j++) {
            arr[j] = parseFloat(arr[j]);
            total1 += arr[j];
        }
        for (var j = 0; j < arr2.length; j++) {
            arr2[j] = parseFloat(arr2[j]);
            total2 += arr2[j];
        }
        var mean1 = total1 / arr.length;
        var mean2 = total2 / arr2.length;
        for (var j = 0; j < arr.length; j++) {
            xm1 += Math.pow((arr[j] - mean1), 2);
        }
        for (var j = 0; j < arr2.length; j++) {
            xm2 += Math.pow((arr2[j] - mean2), 2);
        }
        var sd1 = xm1 / (arr.length - 1);
        var sd2 = xm2 / (arr2.length - 1);
        sd11 = Math.sqrt(sd1);
        sd12 = Math.sqrt(sd2);
        var se = (mean1 - mean2) / Math.sqrt(((arr.length - 1) * sd1 + (arr2.length - 1 * sd2)) / (arr.length + arr2.length - 2) * (arr.length + arr2.length) / (arr.length * arr2.length));
        var tt = (mean1 - mean2) / se;

        var mean_array1 = Math.round(mean1 * 10000) / 10000;
        var mean_array2 = Math.round(mean2 * 10000) / 10000;
        var sd_array1 = Math.round(sd11 * 10000) / 10000;
        var sd_array2 = Math.round(sd12 * 10000) / 10000;
        var t_test_value = Math.round((mean1 - mean2) / Math.sqrt((sd1 / arr.length + sd2 / arr2.length)) * 10000) / 10000;

        var P_Value = StudentT(t_test_value, degF);

        alert("Mean of Array1: " + mean_array1 + " Mean of Array2: " + mean_array2 + " Standard Deviation of Array1: " + sd_array1 + " Standard Deviation of Array2: " + sd_array2 + " T Test value: " + t_test_value + " P value: " + P_Value.toFixed(3));
    }
}

function StudentT(t, n) {
    var Pi = Math.PI;
    var PiD2 = Pi / 2;
    var PiD4 = Pi / 4;
    var Pi2 = 2 * Pi
    var e = 2.718281828459045235;
    var e10 = 1.105170918075647625;
    var Deg = 180 / Pi;
    var t = Math.abs(t);
    var w = t / Math.sqrt(n);
    var th = Math.atan(w);
    var sth = Math.sin(th);
    var cth = Math.cos(th);
    if (n == 1) {
        return 1 - th / PiD2
    }
    var sth = Math.sin(th);
    var cth = Math.cos(th)
    if ((n % 2) == 1) {
        return 1 - (th + sth * cth * Stater(cth * cth, 2, n - 3, -1)) / PiD2
    } else {
        return 1 - sth * Stater(cth * cth, 1, n - 3, -1)
    }
}

function Stater(q, i, j, b) {
    var zz = 1;
    var z = zz;
    var k = i;
    while (k <= j) {
        zz = zz * q * k / (k - b);
        z = z + zz;
        k = k + 2
    }
    return z
}

//////////END of t-test calcs


//reset
function clearArea() {
    canvas.clear();
    document.getElementById("clicksBlue").innerHTML = "";
    document.getElementById("clicksRed").innerHTML = "";
    document.getElementById("clicksGreen").innerHTML = "";
    document.getElementById("clicksYellow").innerHTML = "";
    document.getElementById("clicksBlack").innerHTML = "";
    document.getElementById("clicksGray").innerHTML = "";
    document.getElementById("clicksOrange").innerHTML = "";
    document.getElementById("clicksPurple").innerHTML = "";
    clicksBlack = 0;
    clicksBlue = 0;
    clicksRed = 0;
    clicksGreen = 0;
    clicksYellow = 0;
    clicksGray = 0;
    clicksOrange = 0;
    clicksPurple = 0;
    arg = [];
    arg_Draw = [];
    tempArrayCount = [];
    new_arr_count = [];
    letsBegin();
}
